/*
 * ProgressDialog.h
 *
 *  Created on: Jun 10, 2009
 *      Author: jockeka
 */

#ifndef PROGRESSDIALOG_H_
#define PROGRESSDIALOG_H_

#include <QtGui/QProgressDialog>
class QCloseEvent;

using namespace std;

namespace FS
{
class ApplicationNode;

class ProgressDialog : public QProgressDialog
{
	Q_OBJECT

public:
	ProgressDialog(ApplicationNode *a_applicationNode, const QString & labelText, const QString & cancelButtonText, int minimum, int maximum, QWidget *parent = 0);
    ~ProgressDialog();

    void setMax(int newMax);
    void setVal(int newValue);
    void setValueDownloadingCases(int newValue);
    void setNewText(QString text);
    virtual void closeEvent(QCloseEvent *event);

public slots:
    void cancelFtpDownloading();

private:
	int maxValue;
	ApplicationNode *applicationNode;
	bool removeDirectories();
};

}
#endif /* PROGRESSDIALOG_H_ */
