#include "RegisterUserWindow.h"

using namespace FS;

RegisterUserWindow::RegisterUserWindow(ApplicationNode *applicationNode, QWidget* parent)
: QMainWindow(parent)

{
	this->applicationNode = applicationNode;
	ui.setupUi(this);


	QObject::connect(ui.buttonBox, SIGNAL(rejected ()), applicationNode, SLOT(Quit()));
	QObject::connect(ui.buttonBox, SIGNAL(accepted ()), applicationNode, SLOT(OnAcceptUserData()));
	QObject::connect(ui.usernameLineEdit, SIGNAL(returnPressed ()), applicationNode, SLOT(OnAcceptUserData()));
	QObject::connect(ui.passwordLineEdit, SIGNAL(returnPressed ()), applicationNode, SLOT(OnAcceptUserData()));
	string temp = "v";
	temp = temp + PRODUCTVER;
	ui.versionNo->setText(QString(temp.c_str()));
}

RegisterUserWindow::~RegisterUserWindow()
{
	QObject::disconnect(ui.buttonBox, SIGNAL(rejected ()));
	QObject::disconnect(ui.buttonBox, SIGNAL(accepted ()));
	QObject::disconnect(ui.usernameLineEdit, SIGNAL(returnPressed ()));

	cout << "Destroying RegisterUserWindow"<<endl;
}

void RegisterUserWindow::showFullScreenAndClear()
{
	ui.passwordLineEdit->clear();
	ui.usernameLineEdit->clear();
	ui.usernameLineEdit->setFocus();
	enableButtons( true );
	showFullScreen();
}

void RegisterUserWindow::AskForCredentials()
{
	if( ui.usernameLineEdit->text().isEmpty() )
	{
		QMessageBox::warning( this, "FsWisdom",
				"\nPlease enter user name!\n");

		ui.usernameLineEdit->setFocus();
	}
	else if( ui.passwordLineEdit->text().isEmpty() )
	{
		QMessageBox::warning( this, "FsWisdom",
				"\nPlease enter password!\n");

		ui.passwordLineEdit->setFocus();
	}
	else
	{
		QMessageBox::warning(NULL,tr("Warning!"),
					tr("Database connection not possible, please check user name and password."), QMessageBox::Ok);

		ui.passwordLineEdit->clear();
		ui.usernameLineEdit->clear();
		ui.usernameLineEdit->setFocus();
	}

	enableButtons( true );
}

void RegisterUserWindow::enableButtons( bool bEnable )
{
	ui.buttonBox->setEnabled( bEnable );
	ui.buttonBox->update();
}

void RegisterUserWindow::FtpAborted()
{
	enableButtons(true);
}

void RegisterUserWindow::GetLoginCredentials( QString& rUsername, QString& rPassword )
{
	enableButtons( false );
	rUsername = ui.usernameLineEdit->text();
	rPassword = ui.passwordLineEdit->text();
}


