#ifndef REGISTERUSERWINDOW_H
#define REGISTERUSERWINDOW_H

#include <QtGui/QMainWindow>
#include "ui_RegisterUserWindow.h"
#include "ApplicationNode.h"
#include "VersionNo.h"

namespace FS
{

class ApplicationNode;

class RegisterUserWindow : public QMainWindow
{
    Q_OBJECT

public:
    RegisterUserWindow(ApplicationNode *applicationNode, QWidget* parent = 0);
    ~RegisterUserWindow();
    void showFullScreenAndClear();
    void GetLoginCredentials( QString& rUsername, QString& rPassword );
    void AskForCredentials();
    void FtpAborted();



public slots:

	/**
	 * Checks that the user has entered their name correctly and if so returns control to
	 * the application node via a call to its RegisterUser function
	 */
	//void AcceptUserData();

private:
    void enableButtons(bool bEnable);
    Ui::RegisterUserWindowClass ui;
	ApplicationNode* applicationNode;
};

}

#endif // REGISTERUSERWINDOW_H
