#include "ServerCaseList.h"

using namespace FS;

ServerCaseList::ServerCaseList()
{
	std::vector<CaseMembers> rCaseList;
	if( true == DatabaseHandler::GetInstance()->GetServerCaseList(rCaseList) )
	{
		std::vector<CaseMembers>::const_iterator iter;

		for( iter = rCaseList.begin(); iter != rCaseList.end(); iter++ )
		{
			QString caseName = iter->Name;
			unsigned int caseVersion = iter->version;
			std::cout << caseName.toStdString() << caseVersion<< std::endl;
			insert(begin(), std::pair<QString, Case>(caseName, Case(caseName, caseVersion)));
		}
	}
	else
		std::cout <<  "Failed to read list of cases form server" << std::endl;
}

void ServerCaseList::syncWithLocal(ApplicationNode *applicationNode, LocalCaseList& localCaseList) const
{
	const_iterator serverCase = begin();
	// for every case on the server, check if we need to
	// a) install the case for the first time since it isn't installed locally
	// b) install the latest version of the case locally
	for(serverCase=begin(); serverCase!=end(); serverCase++)
		localCaseList.addLocally(Case(((*serverCase).second).getName(), ((*serverCase).second).getVersion()));

	//Start download over ftp.
	if (localCaseList.ftpDownloadVector.size() != 0)
	{
		applicationNode->getProgressDialog()->setMax(localCaseList.ftpDownloadVector.size());
		std::vector<QString>::iterator it ;
		for(it=localCaseList.ftpDownloadVector.begin(); it!=localCaseList.ftpDownloadVector.end(); it++)
			std::cout << "ftpDownloadVector: " << (*it).toStdString() << std::endl;

		QString temp = localCaseList.ftpDownloadVector.back();
		localCaseList.ftpDownloadVector.pop_back();
		localCaseList.ftpDownload(temp);
	}
	else
	{
		localCaseList.ftpDownload(NULL);
	}

}
