/**
 * ServerCaseList.h
 *
 *  Created on: May 7, 2009
 *      Author: barrygr
 */

#ifndef SERVER_CASE_LIST_H_
#define SERVER_CASE_LIST_H_

#include "CaseList.h"
#include "LocalCaseList.h"
#include "DatabaseHandler.h"
#include <QDir>
#include <vector>

namespace FS
{
class LocalCaseList;
/*
 * A map of cases as they exist on the forssim server
 */
class ServerCaseList : public CaseList
{
public:
	/**
	 * The database connection
	 */
	ServerCaseList();

	/**
	 * Synchronize the local cases with those stored on the server.
	 * For example, update cases with there most recent versions
	 */
	void syncWithLocal(ApplicationNode *applicationNode, LocalCaseList& localCaseList) const;

};

}
#endif //SERVER_CASE_LIST_H_
