/*
 * Updater_QButton_NextState.h
 *
 *  Created on: Feb 13, 2009
 *      Author: parhe
 */

#ifndef UPDATER_QBUTTON_NEXTSTATE_H_
#define UPDATER_QBUTTON_NEXTSTATE_H_

#include <QtGui>
#include "../src/StateMachine.h"
#include <H3D/X3D.h>
#include <iostream>

using namespace H3D;

/**
 *	\brief Switch to the next state when this button is clicked
 */

namespace FS
{
class Updater_QButton_NextState : public QObject
{
public:
	Q_OBJECT

public:
	/**
	 * Constructor
	 * \param button A button object which when click activates steps into the next state.
	 * \stateMachine A statemachine node.
	 */

	Updater_QButton_NextState(QPushButton* button, StateMachine* stateMachine);
	virtual ~Updater_QButton_NextState();

public slots:

/**
 * Set the statemachine into the next state.
 */
void updateFieldRoutedTo();

private:
	QPushButton* button;
	StateMachine* stateMachine;
};

}

#endif /* UPDATER_QSLIDER_SFFLOAT_H_ */
