/*
 * Updater_QButton_Playback.cpp
 *
 *  Created on: Feb 13, 2009
 *      Author: jockeka
 */

#include "Updater_QButton_Playback.h"

#include <QtGui>
#include "../src/AVolumePlaybackNode.h"
#include <H3D/X3D.h>

using namespace FS;


Updater_QButton_Playback::Updater_QButton_Playback(QPushButton* button, SFBool* fieldToRouteTo)
{
	this->fieldToRouteTo = fieldToRouteTo;
	this->setValue(fieldToRouteTo->getValue());
	this->button = button;
	this->route(fieldToRouteTo);
	fieldToRouteTo->route(this);

	QObject::connect(button, SIGNAL(clicked()), this, SLOT(playstop()));

}

Updater_QButton_Playback::~Updater_QButton_Playback()
{
	std::cout << "Destroying: Updater_QButton_Playback" << std::endl;
	this->unrouteAll();
	QObject::disconnect(button, SIGNAL(clicked()));
}

void Updater_QButton_Playback::update()
{
	SFBool value = static_cast< SFBool * >(routes_in[0])->getValue();
	if (value.getValue() == true)
	{
		button->setText("Pause");
	}
	else
	{
		button->setText("Play");
	}
}
void Updater_QButton_Playback::playstop()
{
	fieldToRouteTo->setValue(!(fieldToRouteTo->getValue()));
	if (fieldToRouteTo->getValue() == true)
	{
		button->setText("Pause");
	}
	else
	{
		button->setText("Play");
	}
}
