/*
 * Updater_QButton_Playback.h
 *
 *  Created on: Feb 13, 2009
 *      Author: jockeka
 */

#ifndef UPDATER_QBUTTON_PLAYBACK_H_
#define UPDATER_QBUTTON_PLAYBACK_H_

#include <QtGui>
#include "../src/AVolumePlaybackNode.h"
#include <H3D/X3D.h>

using namespace H3D;

/**
 * \brief Adds play/pause functionality to a button
 */

namespace FS
{
class Updater_QButton_Playback : public QObject, public AutoUpdate< SFBool >
{
public:
	Q_OBJECT

public:

	/**
	 * Constructor
	 * \param button the button which will own the functionality
	 * \param fieldToRouteTo the field in the playcback node which controles the direction
	 */
	Updater_QButton_Playback(QPushButton* button, SFBool* fieldToRouteTo);

	virtual ~Updater_QButton_Playback();

	/**
	 * Set the text of the button if the direction changes
	 */
	void update();

public slots:

/**
 * When the button is clicked, this slot routes the value as well as changes the value.
 */
void playstop();


private:
	SFBool* fieldToRouteTo;
	QPushButton* button;
};

}

#endif /* UPDATER_QBUTTON_PLAYBACK_H_ */
