/*
 * Updater_QButton_RemovePartitionByName.h
 *
 *  Created on: Feb 13, 2009
 *      Author: parhe
 */

#ifndef UPDATER_QBUTTON_REMOVEPARTITIONBYNAME_H_
#define UPDATER_QBUTTON_REMOVEPARTITIONBYNAME_H_

#include <QtGui>
#include <H3D/X3D.h>
#include "../src/VolumeModel.h"

using namespace H3D;

/**
 * \brief Removes a partition by its name e.g crownroot...etc
 */
namespace FS
{
	class Updater_QButton_RemovePartitionByName : public QObject
	{
	public:
	    Q_OBJECT

	public:
/**
 * Constructor
 * \param button the button which removes a part by its name
 * \param volumeModel a pointer to the volume model node
 * \param partitionName The part which should be removed upon click
 */
		Updater_QButton_RemovePartitionByName(QPushButton* button, VolumeModel* volumeModel, string partitionName);
		virtual ~Updater_QButton_RemovePartitionByName();

	public slots:

	/**
	 * When the button is clicked the partition is removed
	 */
	void clicked();

	private:
		QPushButton* button;
		VolumeModel* volumeModel;
		string partitionName;
};

}

#endif /* UPDATER_QBUTTON_REMOVEPARTITIONBYNAME_H_ */
