/*
 * Updater_QButton_SFBoolPB.h
 *
 *  Created on: Feb 13, 2009
 *      Author: jockeka
 */

#ifndef UPDATER_QBUTTON_SFFLOATPB_H_
#define UPDATER_QBUTTON_SFFLOATPB_H_


#include <QtGui>
#include "../src/MaterialSegmentationModel.h"
#include <H3D/X3D.h>

using namespace H3D;

/**
 *
 */
namespace FS
{
	class Updater_QButton_SFBoolPB : public QObject, public AutoUpdate< SFBool >
	{
	public:
	    Q_OBJECT

	public:

		Updater_QButton_SFBoolPB(QPushButton* button, SFBool* fieldToRouteTo)
		{
			this->button = button;
			this->fieldToRouteTo = fieldToRouteTo;
			this->setValue(fieldToRouteTo->getValue());

			this->route(fieldToRouteTo);

			QObject::connect(button, SIGNAL(clicked()), this, SLOT(updateFieldRoutedTo()));
		}

		virtual ~Updater_QButton_SFBoolPB()
		{
			std::cout << "Destroying: Updater_QButton_SFBoolPB" << std::endl;
			this->unrouteAll();
			QObject::disconnect(button, SIGNAL(clicked()));
		}

	public slots:
		inline void updateFieldRoutedTo()
		{
			fieldToRouteTo->setValue(true);
		}
	private:
		QPushButton* button;
		SFBool* fieldToRouteTo;
	};

}

#endif /* UPDATER_QBUTTON_SFFLOAT_H_ */
