/*
 * Updater_QButton_SFFloat.h
 *
 *  Created on: Feb 13, 2009
 *      Author: parhe
 */

#ifndef UPDATER_QBUTTON_SFFLOAT_H_
#define UPDATER_QBUTTON_SFFLOAT_H_


#include <QtGui>
#include "../src/AVolumePlaybackNode.h"
#include <H3D/X3D.h>

using namespace H3D;

/**
 *
 */
namespace FS
{
	class Updater_QButton_SFFloat : public QObject, public AutoUpdate< SFFloat >
	{
	public:
	    Q_OBJECT

	public:

		Updater_QButton_SFFloat(QPushButton* button, SFFloat* fieldToRouteTo, float value,AVolumePlaybackNode* playbackNode)
		{
			this->button = button;
			this->fieldToRouteTo = fieldToRouteTo;
			this->setValue(fieldToRouteTo->getValue());

			this->route(fieldToRouteTo);
			this->value = value;
			this->playbackNode = playbackNode;
			QObject::connect(button, SIGNAL(clicked()), this, SLOT(updateFieldRoutedTo()));
		}

		virtual ~Updater_QButton_SFFloat()
		{
			std::cout << "Destroying: Updater_QButton_SFFloat" << std::endl;
			this->unrouteAll();
			QObject::disconnect(button, SIGNAL(clicked()));
		}

	public slots:
		inline void updateFieldRoutedTo()
		{
			fieldToRouteTo->setValue(value);
		}
	private:
		QPushButton* button;
		SFFloat* fieldToRouteTo;
		float value;
		AVolumePlaybackNode* playbackNode;
	};

}

#endif /* UPDATER_QBUTTON_SFFLOAT_H_ */
