/*
 * Updater_QButton_SFInt32_Drill_Elevator.cpp
 *
 *  Created on: Sep 1, 2009
 *      Author: jockeka
 */

#include "Updater_QButton_SFInt32_Drill_Elevator.h"

using namespace FS;

Updater_QButton_SFInt32_Drill_Elevator::Updater_QButton_SFInt32_Drill_Elevator(Ui::RemoveWisdomToothWindowClass ui, SFInt32* fieldToRouteTo)
{
	cout << "Updater_QButton_SFInt32_Drill_Elevator Constructing" << endl;

	if (!fieldToRouteTo)
	{
		return;
	}

	this->ui = ui;
	this->fieldToRouteTo = fieldToRouteTo;
	//this->setValue(fieldToRouteTo->getValue());
	fieldToRouteTo->route(this);

	cout << "Updater_QButton_SFInt32_Drill_Elevator Constructed" << endl;
}

Updater_QButton_SFInt32_Drill_Elevator::~Updater_QButton_SFInt32_Drill_Elevator()
{
	cout << "Destroying: Updater_QButton_SFInt32_Drill_Elevator" << endl;
	this->unrouteAll();
}

void Updater_QButton_SFInt32_Drill_Elevator::update()
{
	int deviceShape = static_cast< SFInt32 * >(routes_in[0])->getValue();
	switch (deviceShape) {
		case 0:
			//Drill off
			ui.selectDrillButton->setChecked(true);
			ui.selectElevatorButton->setChecked(false);
			ui.toolButton->setChecked(true);
			break;
		case 1:
			//Elevator
			ui.selectDrillButton->setChecked(false);
			ui.selectElevatorButton->setChecked(true);
			ui.toolButton->setChecked(true);
			break;
		case 2:
			//No tool
			//No need to do anything since this can only be set from GUI.
			break;
		case 3:
			//Drill on
			ui.selectDrillButton->setChecked(true);
			ui.selectElevatorButton->setChecked(false);
			ui.toolButton->setChecked(true);
			break;
		default:
			cout << "Updater_QButton_SFInt32_Drill_Elevator::update() Undefined value in deviceShape!" << endl;
	}
}
