/*
 * Updater_QButton_SaveAndExit.cpp
 *
 *  Created on: Feb 13, 2009
 *      Author: parhe
 */

#include "Updater_QButton_SaveAndExit.h"

using namespace FS;

Updater_QButton_SaveAndExit::Updater_QButton_SaveAndExit(ApplicationNode* applicationNode, QPushButton* button, VolumeModel* volumeModel)
{
	cout << "Updater_QButton_SaveAndExit Constructing" << endl;

	this->applicationNode = applicationNode;
	this->button = button;

	this->volumeModel = volumeModel;

	QObject::connect(button, SIGNAL(clicked()), this, SLOT(saveTimestamps()));

	cout << "Updater_QButton_SaveAndExit Constructed" << endl;
}

Updater_QButton_SaveAndExit::~Updater_QButton_SaveAndExit()
{
	std::cout << "Destroying: Updater_QButton_SaveAndExit" << std::endl;
	QObject::disconnect(button, SIGNAL(clicked()));
}

void Updater_QButton_SaveAndExit::saveTimestamps()
{
	applicationNode->setOverrideCursor(QCursor(Qt::WaitCursor));

	volumeModel->saveTimeStamps();

	applicationNode->restoreOverrideCursor();
	applicationNode->quit();
}
