/**
 * Updater_QDial_Int32.h
 *
 *  Created on: Feb 12, 2009
 *      Author: barrygr
 */

#ifndef UPDATER_QDIAL_SFINT32_H_
#define UPDATER_QDIAL_SFINT32_H_

#include <QtGui>
#include <QDial>
#include <H3D/FieldTemplates.h>
#include <H3D/SFInt32.h>

using namespace H3D;

/**
 *
 */
namespace FS
{
	class Updater_QDial_SFInt32 : public QObject, public AutoUpdate< SFInt32 >
	{
	public:
	    Q_OBJECT

	public:

		Updater_QDial_SFInt32(QDial* dial, SFInt32* fieldToRouteTo)
		{
			if(!fieldToRouteTo)
			{
				dial->setEnabled(false);
				dial->setNotchesVisible(false);
				connected = false;
				return;
			}
			else
				connected = true;

			dial->setEnabled(true);
			dial->setNotchesVisible(true);

			this->dial = dial;
			this->fieldToRouteTo = fieldToRouteTo;

			this->setValue(fieldToRouteTo->getValue());

			this->route(fieldToRouteTo);
			fieldToRouteTo->route(this);

			QObject::connect(dial, SIGNAL(valueChanged (int)), this, SLOT(updateFieldRoutedTo(int)));
		}

		virtual ~Updater_QDial_SFInt32()
		{
			std::cout << "Destroying: Updater_QDial_SFInt32" << std::endl;
			if(connected)
			{
				this->unrouteAll();
				QObject::disconnect(dial, SIGNAL(valueChanged (int)));
			}
		}

		virtual void update()
		{
			int value = static_cast< SFInt32 * >(routes_in[0])->getValue();
			dial->setValue(value);
		}
	public slots:
		inline void updateFieldRoutedTo(int value)
		{
		    fieldToRouteTo->setValue(value);
		}
	private:
		QDial* dial;
		SFInt32* fieldToRouteTo;
		bool connected;

	};

}
#endif /* UPDATER_QDIAL_SFINT32_H_ */
