/**
 * Updater_QLabel_MFFloat.cpp
 *
 *  Created on: Mar 25, 2009
 *      Author: barrygr
 */

#include "Updater_QLabel_MFInt32.h"

using namespace FS;

Updater_QLabel_MFInt32::Updater_QLabel_MFInt32(vector<QLabel*> labels, MFInt32* fieldToRouteTo)
	:labels(labels)
{
	cout << "Constructing Updater_QLabel_MFInt32" << endl;

	if(labels.size()!=fieldToRouteTo->size())
		throw Updater_QLabel_MFInt32Exception("The number of labels in labels should match the length of fieldToRouteTo");

	this->fieldToRouteTo = fieldToRouteTo;
	this->setValue(fieldToRouteTo->getValue());
	fieldToRouteTo->route(this);

	cout << "Constructed Updater_QLabel_MFInt32" << endl;
}

Updater_QLabel_MFInt32::~Updater_QLabel_MFInt32()
{
	cout << "Destroying Updater_QLabel_MFInt32" << endl;
	this->unrouteAll();

}

void Updater_QLabel_MFInt32::update()
{
	const vector<H3DInt32> &values = static_cast< MFInt32 * >(routes_in[0])->getValue();

	vector<QLabel*>::iterator i;
	vector<H3DInt32>::const_iterator j;

	for(i=labels.begin(),j=values.begin();i<labels.end();i++,j++)
	{
		if(*i != NULL)
		{
			QString newLabelValue;
			newLabelValue.setNum(*j);
			(*i)->setText(QString(newLabelValue));
		}
	}
}
