/**
 * Updater_QLabel_SFRotation.h
 *
 *  Created on: Feb 12, 2009
 *      Author: parhe
 */

#ifndef UPDATER_QLABEL_SFROTATION_H_
#define UPDATER_QLABEL_SFROTATION_H_


#include <QtGui>


#include <H3D/X3D.h>

#include <iostream>

#include "ui_RemoveWisdomToothWindow.h"

#include <H3D/SFFloat.h>
#include <H3D/SFRotation.h>

using namespace H3D;

/**
 *
 */
namespace FS
{
class Updater_QLabel_SFRotation : public QObject, public AutoUpdate< SFRotation >
{
public:
		Q_OBJECT


public:

	Updater_QLabel_SFRotation(Ui::RemoveWisdomToothWindowClass ui, QLabel* label, QRadioButton* radio, SFRotation* fieldToRouteTo, SFFloat* zoomFactor, int tab)
	{
		this->label = label;
		this->radio = radio;
		this->fieldToRouteTo = fieldToRouteTo;
		this->zoomFactor = zoomFactor;
		this->setValue(fieldToRouteTo->getValue());
		this->ui = ui;
		this->tab = tab;
		this->route(fieldToRouteTo);
		fieldToRouteTo->route(this);

		if (tab == 0)
		{//Tab adv
			QObject::connect(ui.rotationPlusX, SIGNAL(clicked()), this, SLOT(rotatePlusX()));
			QObject::connect(ui.rotationPlusY, SIGNAL(clicked()), this, SLOT(rotatePlusY()));
			QObject::connect(ui.rotationPlusZ, SIGNAL(clicked()), this, SLOT(rotatePlusZ()));
			QObject::connect(ui.rotationMinusX, SIGNAL(clicked()), this, SLOT(rotateMinusX()));
			QObject::connect(ui.rotationMinusY, SIGNAL(clicked()), this, SLOT(rotateMinusY()));
			QObject::connect(ui.rotationMinusZ, SIGNAL(clicked()), this, SLOT(rotateMinusZ()));
		}
		else if (tab == 1)
		{//Tab user
			QObject::connect(ui.rotationPlusY_2, SIGNAL(clicked()), this, SLOT(rotatePlusY()));
			QObject::connect(ui.rotationPlusZ_2, SIGNAL(clicked()), this, SLOT(rotatePlusZ()));
			QObject::connect(ui.rotationMinusY_2, SIGNAL(clicked()), this, SLOT(rotateMinusY()));
			QObject::connect(ui.rotationMinusZ_2, SIGNAL(clicked()), this, SLOT(rotateMinusZ()));
		}
	}

	virtual ~Updater_QLabel_SFRotation()
	{
		std::cout << "Destroying: Updater_QLabel_SFRotation" << std::endl;
		this->unrouteAll();

		if (tab == 0)
		{//Tab adv
			QObject::disconnect(ui.rotationPlusX, SIGNAL(clicked()));
			QObject::disconnect(ui.rotationPlusY, SIGNAL(clicked()));
			QObject::disconnect(ui.rotationPlusZ, SIGNAL(clicked()));
			QObject::disconnect(ui.rotationMinusX, SIGNAL(clicked()));
			QObject::disconnect(ui.rotationMinusY, SIGNAL(clicked()));
			QObject::disconnect(ui.rotationMinusZ, SIGNAL(clicked()));
		}
		else if (tab == 1)
		{//Tab user
			QObject::disconnect(ui.rotationPlusY_2, SIGNAL(clicked()));
			QObject::disconnect(ui.rotationPlusZ_2, SIGNAL(clicked()));
			QObject::disconnect(ui.rotationMinusY_2, SIGNAL(clicked()));
			QObject::disconnect(ui.rotationMinusZ_2, SIGNAL(clicked()));
		}
	}

	virtual void update()
	{
		SFRotation value = static_cast< SFRotation * >(routes_in[0])->getValue();

				label->setText(QString().setNum(value.getValue().axis.x,'f',4)
						+" "+QString().setNum(value.getValue().axis.y,'f',4)
						+" "+QString().setNum(value.getValue().axis.z,'f',4)
						+" "+QString().setNum(value.getValue().angle,'f',4)
						);
	}

public slots:
inline void rotatePlusX()
{
	if (this->radio->isChecked())
	{
		Rotation rot = Rotation(1,0,0,1*zoomFactor->getValue());
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() * rot);
	}
}

inline void rotateMinusX()
{
	if (this->radio->isChecked())
	{
		Rotation rot = Rotation(1,0,0,-1*zoomFactor->getValue());
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() * rot);
	}
}

inline void rotatePlusY()
{
	if (this->radio->isChecked())
	{
		Rotation rot = Rotation(0,1,0,1*zoomFactor->getValue());
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() * rot);
	}
}
inline void rotateMinusY()
{
	if (this->radio->isChecked())
	{
		Rotation rot = Rotation(0,1,0,-1*zoomFactor->getValue());
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() * rot);
	}
}
inline void rotatePlusZ()
{
	if (this->radio->isChecked())
	{
		Rotation rot = Rotation(0,0,1,1*zoomFactor->getValue());
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() * rot);
	}
}
inline void rotateMinusZ()
{
	if (this->radio->isChecked())
	{
		Rotation rot = Rotation(0,0,1,-1*zoomFactor->getValue());
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() * rot);
	}
}

private:
	QLabel* label;
	QRadioButton* radio;
	SFRotation* fieldToRouteTo;
	SFFloat* zoomFactor;
	Ui::RemoveWisdomToothWindowClass ui;
	int tab;
};

}
#endif /* UPDATER_QLABEL_SFROTATION_H_ */
