/**
 * Updater_QLabel_SFTranslation.h
 *
 *  Created on: Feb 12, 2009
 *      Author: parhe
 */

#ifndef UPDATER_QLABEL_SFTRANSLATION_H_
#define UPDATER_QLABEL_SFTRANSLATION_H_

#include <QtGui>
#include <H3D/X3D.h>

#include <iostream>

#include <stdio.h>
#include "ui_RemoveWisdomToothWindow.h"

#include <H3D/SFFloat.h>

using namespace H3D;

/**
 *
 */
namespace FS
{
class Updater_QLabel_SFTranslation : public QObject, public AutoUpdate< SFVec3f >
{
public:
	Q_OBJECT


public:
	Updater_QLabel_SFTranslation(Ui::RemoveWisdomToothWindowClass ui, QLabel* label, QRadioButton* radio, SFVec3f* fieldToRouteTo, SFFloat* zoomFactor)
	{

		this->label = label;
		this->radio = radio;
		this->fieldToRouteTo = fieldToRouteTo;
		this->zoomFactor = zoomFactor;
		this->setValue(fieldToRouteTo->getValue());
		this->ui = ui;

		this->route(fieldToRouteTo);
		fieldToRouteTo->route(this);

		//		QObject::connect(radio, SIGNAL(toggled (bool)), this, SLOT(isSelected(bool)));

		QObject::connect(ui.translationPlusX, SIGNAL(clicked()), this, SLOT(translationPlusX()));
		QObject::connect(ui.translationPlusY, SIGNAL(clicked()), this, SLOT(translationPlusY()));
		QObject::connect(ui.translationPlusZ, SIGNAL(clicked()), this, SLOT(translationPlusZ()));
		QObject::connect(ui.translationMinusX, SIGNAL(clicked()), this, SLOT(translationMinusX()));
		QObject::connect(ui.translationMinusY, SIGNAL(clicked()), this, SLOT(translationMinusY()));
		QObject::connect(ui.translationMinusZ, SIGNAL(clicked()), this, SLOT(translationMinusZ()));

	}

	virtual ~Updater_QLabel_SFTranslation(){
		cout<<"Destroying Updater_QLabel_SFTranslation"<<endl;
		QObject::disconnect(ui.translationPlusX, SIGNAL(clicked()));
		QObject::disconnect(ui.translationPlusY, SIGNAL(clicked()));
		QObject::disconnect(ui.translationPlusZ, SIGNAL(clicked()));
		QObject::disconnect(ui.translationMinusX, SIGNAL(clicked()));
		QObject::disconnect(ui.translationMinusY, SIGNAL(clicked()));
		QObject::disconnect(ui.translationMinusZ, SIGNAL(clicked()));
		this->unrouteAll();
	}



	virtual void update()
	{
		SFVec3f value = static_cast< SFVec3f * >(routes_in[0])->getValue();

		label->setText(QString().setNum(value.getValue().x,'f',4)
				+" "+QString().setNum(value.getValue().y,'f',4)
				+" "+QString().setNum(value.getValue().z,'f',4));
	}

public slots:

inline void translationPlusX()
{
	if (this->radio->isChecked())
	{
		Vec3f pos;
		pos.x = zoomFactor->getValue();;
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() + pos);
	}
}
inline void translationMinusX()
{
	if (this->radio->isChecked())
	{
		Vec3f pos;
		pos.x = zoomFactor->getValue();;
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() - pos);
	}
}
inline void translationPlusY()
{
	if (this->radio->isChecked())
	{
		Vec3f pos;
		pos.y = zoomFactor->getValue();;
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() + pos);
	}
}
inline void translationMinusY()
{
	if (this->radio->isChecked())
	{
		Vec3f pos;
		pos.y = zoomFactor->getValue();
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() - pos);
	}
}
inline void translationPlusZ()
{
	if (this->radio->isChecked())
	{
		Vec3f pos;
		pos.z = zoomFactor->getValue();
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() + pos);
	}
}

inline void translationMinusZ()
{
	if (this->radio->isChecked())
	{
		Vec3f pos;
		pos.z = zoomFactor->getValue();
		fieldToRouteTo->setValue(fieldToRouteTo->getValue() - pos);
	}
}



private:
	QLabel* label;
	QRadioButton* radio;
	SFVec3f* fieldToRouteTo;
	SFFloat *zoomFactor;
	Ui::RemoveWisdomToothWindowClass ui;

};

}
#endif /* UPDATER_QLABEL_SFROTATION_H_ */
