/**
 * Updater_QLabel_Vec3f.h
 *
 *  Created on: Feb 12, 2009
 *      Author: parhe
 */

#ifndef UPDATER_QLABEL_SFVEC3F_H_
#define UPDATER_QLABEL_SFVEC3F_H_

#include <QtGui>

#include <H3D/X3D.h>
#include "../src/DefaultValues.h"
#include "../src/StateMachine.h"
#include <iostream>
#include <sstream>
#include "ui_RemoveWisdomToothWindow.h"

using namespace H3D;

/**
 *
 */
namespace FS
{
class Updater_QLabel_SFVec3f : public QObject, public AutoUpdate< SFVec3f >
{
public:
	Q_OBJECT







public:

	Updater_QLabel_SFVec3f(QLabel* label, SFVec3f* fieldToRouteTo,int type,Ui::RemoveWisdomToothWindowClass ui,StateMachine* stateMachine)
	{
		this->label = label;
		this->fieldToRouteTo = fieldToRouteTo;
		this->setValue(fieldToRouteTo->getValue());
		this->type = type;
		this->ui=ui;
		this->stateMachine = stateMachine;
//Route only from x3d into gui not the other way around
//		this->route(fieldToRouteTo);
		fieldToRouteTo->route(this);

	}
virtual ~Updater_QLabel_SFVec3f(){
	cout<<"Destroying Updater_QLabel_SFVec3f" << endl;
	this->unrouteAll();
}

	virtual void update()
	{
		SFVec3f value = static_cast< SFVec3f * >(routes_in[0])->getValue();
		label->setText(QString().setNum(value.getValue().x,'f',4)
			+ " " + QString().setNum(value.getValue().y,'f',4)
			+ " " + QString().setNum(value.getValue().z,'f',4)

		);

		if (type == 0)
		{
			ui.distance->setText((QString().setNum(stateMachine->getDistance().getValue(),'f',4)));
		}
		else if (type== 1)
		{
			ui.absolutForce->setText((QString().setNum(stateMachine->getAbsoluteForce().getValue(),'f',4)));
		}
	}

public slots:
inline void updateFieldRoutedTo(H3D::SFVec3f value)
{
//	fieldToRouteTo->setValue(value);
}
private:
	QLabel* label;
	SFVec3f* fieldToRouteTo;
	int type;
	Ui::RemoveWisdomToothWindowClass ui;
	SFFloat absoluteForce;
	SFFloat distance;
	StateMachine* stateMachine;
	float nrOfDecimals;
};

}
#endif /* UPDATER_QLABEL_SFVEC3F_H_ */
