/*
 * Updater_QProgressBar_PlaybackProgressBar.cpp
 *
 *  Created on: Mars 30, 2009
 *      Author: jockeka
 */

#include "Updater_QProgressBar_PlaybackProgressBar.h"

using namespace FS;

Updater_QProgressBar_PlaybackProgressBar::Updater_QProgressBar_PlaybackProgressBar(QProgressBar* bar, SFFloat* fieldToRouteTo, AVolumePlaybackNode* playbackNode, VolumeModel* volumeModel)
{
	cout << "Updater_QProgressBar_PlaybackProgressBar Constructing" << endl;

	this->bar = bar;
	this->playbackNode = playbackNode;
	this->volumeModel = volumeModel;
	this->fieldToRouteTo = fieldToRouteTo;
	this->setValue(fieldToRouteTo->getValue());
	fieldToRouteTo->route(this);

	cout << "Updater_QProgressBar_PlaybackProgressBar Constructed" << endl;
}
Updater_QProgressBar_PlaybackProgressBar::~Updater_QProgressBar_PlaybackProgressBar(){
	cout<<"Destroying Updater_QProgressBar_PlaybackProgressBar"<<endl;
	this->unrouteAll();

}

void Updater_QProgressBar_PlaybackProgressBar::update()
{
	SFFloat playbackTime = static_cast< SFFloat * >(routes_in[0])->getValue();
	float temp = playbackTime.getValue()/playbackNode->getEndTime(); /*This value could also be extracted from the timestamp_map directly, which is fastest?*/
	if (temp > 1)
	{
		bar->setValue(bar->maximum());
	}
	else
	{
		bar->setValue((int)((temp*bar->maximum())+0.5));
	}
}
