/**
 * Updater_QLabel_SFBool.h
 *
 *  Created on: May 5, 2009
 *      Author: barrygr
 */

#include "Updater_QLabel_SFBool.h"

using namespace FS;

Updater_QLabel_SFBool::Updater_QLabel_SFBool(QRadioButton* radioButton, SFBool* fieldToRouteTo)
{
	this->fieldToRouteTo = fieldToRouteTo;
	this->radioButton = radioButton;

	// nothing to route to
	if(!fieldToRouteTo)
	{
		radioButton->setStyleSheet("background-color: rgb(255, 85, 127);");
		radioButton->setEnabled(false);
		return;
	}
	else
	{
		radioButton->setStyleSheet("background-color: rgb(170, 255, 127);");
		radioButton->setEnabled(true);
	}

	this->setValue(fieldToRouteTo->getValue());

	fieldToRouteTo->route(this);
}
Updater_QLabel_SFBool::~Updater_QLabel_SFBool(){
	cout<<"Destroying Updater_QLabel_SFBool"<<endl;
	this->unrouteAll();

}

void Updater_QLabel_SFBool::update()
{
	SFBool value = static_cast< SFBool * >(routes_in[0])->getValue();
	radioButton->setText(QString().setNum(value.getValue(),'f',4));
}

void Updater_QLabel_SFBool::updateFieldRoutedTo(H3DFloat value)
{
	fieldToRouteTo->setValue(value);
}


