/*
 * Updater_QSlider_SFFloat.h
 *
 *  Created on: Feb 13, 2009
 *      Author: parhe
 */

#ifndef UPDATER_QSLIDER_SFFLOAT_H_
#define UPDATER_QSLIDER_SFFLOAT_H_

#include <QtGui>
#include <H3D/X3D.h>
#include <H3D/SFFloat.h>

using namespace H3D;

/**
 *
 */
namespace FS
{
	class Updater_QSlider_SFFloat : public QObject, public AutoUpdate< SFFloat >
	{
	public:
	    Q_OBJECT

	public:

		Updater_QSlider_SFFloat(QSlider* slider, QLabel* label, SFFloat* fieldToRouteTo, float max, float incrementBy)
		{
			this->slider = slider;
			this->label = label;
			this->fieldToRouteTo = fieldToRouteTo;

			this->max=max;
			this->incrementBy=incrementBy;

			this->slider->setMaximum ((int) (max/incrementBy));
			this->setValue(fieldToRouteTo->getValue());

			this->route(fieldToRouteTo);
			fieldToRouteTo->route(this);

			QObject::connect(slider, SIGNAL(valueChanged (int)), this, SLOT(updateFieldRoutedTo(int)));
		}

		virtual ~Updater_QSlider_SFFloat(){
			cout<<"Destroying Updater_QSlider_SFFloat"<<endl;
			QObject::disconnect(slider, SIGNAL(valueChanged (int)));
			this->unrouteAll();
		}


		virtual void update()
		{
			SFFloat value = static_cast< SFFloat * >(routes_in[0])->getValue();
			slider->setValue(value.getValue()/incrementBy);
			std::string s = value.getValueAsString();
			label->setText(s.c_str());
		}


	public slots:
		inline void updateFieldRoutedTo(int value)
		{
		    fieldToRouteTo->setValue((float)(value)*incrementBy);
		}
	private:
		QSlider* slider;
		QLabel* label;
		SFFloat* fieldToRouteTo;
		float max;
		float incrementBy;
	};

}

#endif /* UPDATER_QSLIDER_SFFLOAT_H_ */
