/**
 * Updater_QTableWidget.cpp
 *
 *  Created on: May 29, 2009
 *      Author: parhe
 */

#include "Updater_QTableWidget.h"

using namespace FS;

Updater_QTableWidget::Updater_QTableWidget(QTableWidget* table, MFInt32* fieldToRouteTo, MFInt32* noOfForbiddenVoxels, DrillingStepsNode * drillingStepsNode)
{
	cout << "Constructing Updater_QTableWidget" << endl;


	this->table = table;
	this->noOfForbiddenVoxels = noOfForbiddenVoxels;
	this->fieldToRouteTo = fieldToRouteTo;
	this->drillingStepsNode = drillingStepsNode;
	this->setValue(fieldToRouteTo->getValue());

	fieldToRouteTo->route(this);

	cout << "Constructed Updater_QTableWidget" << endl;
}

Updater_QTableWidget::~Updater_QTableWidget()
{
	cout << "Destroying Updater_QTableWidget" << endl;
	this->unrouteAll();
}


void Updater_QTableWidget::update()
{

	const vector<H3DInt32> &values = static_cast< MFInt32 * >(routes_in[0])->getValue();

	const vector<H3DInt32> &forbidden = static_cast< MFInt32 * >(noOfForbiddenVoxels)->getValue();

	vector<H3DInt32>::const_iterator j;

	int expertVoxelsDrilledTotal = 0;
	int  voxelsDrilledTotal = 0;
	int expertVoxelsTotal = 0;
	QString newString;
	int i;

	for( i=0,j=++(values.begin());j<values.end();j++, i++)
	{
		table->setItem( i,1, new QTableWidgetItem(QString(newString.setNum(*j))));

		voxelsDrilledTotal += (int) *j ;
		int expertVoxelsDrilled = this->drillingStepsNode->noOfExpertVoxelsDrilledByUserForCurrentDrillingStep(i+1);
		int expertVoxels = this->drillingStepsNode->noOfVoxelsDrilledByExpertForCurrentDrillingStep(i+1);

		if (expertVoxels==0){
			table->setItem( i,2, new QTableWidgetItem(QString("-")));
			table->setItem( i,3, new QTableWidgetItem(QString("-")));
		}
		else{
			table->setItem( i,2, new QTableWidgetItem(QString(newString.setNum(expertVoxelsDrilled))));
			table->setItem( i,3, new QTableWidgetItem(QString(newString.setNum((float)expertVoxelsDrilled/(float)expertVoxels))));

		}
		expertVoxelsDrilledTotal += expertVoxelsDrilled;
		expertVoxelsTotal += expertVoxels;
	}

	//removed 1 from values.size since air is not considered
	table->setItem( values.size()-1,1, new QTableWidgetItem(QString(newString.setNum(voxelsDrilledTotal))));
	table->setItem( values.size()-1,2,  new QTableWidgetItem(QString(newString.setNum(expertVoxelsDrilledTotal))));
	table->setItem( values.size()-1,3, new QTableWidgetItem(QString(newString.setNum((float)expertVoxelsDrilledTotal/(float)expertVoxelsTotal))));


	//Set the font to bold
	QFont f =table->item(values.size()-1,1)->font();
	f.setBold(true);

	table->item( values.size()-1,1)->setFont(f);
	table->item( values.size()-1,2)->setFont(f);
	table->item( values.size()-1,3)->setFont(f);

	//Added 1 since we have a added "forbidden" headline also ++ due not interested in the total
	for( i=values.size(),j=++(forbidden.begin());j<forbidden.end();j++, i++)
	{
		table->setItem( i,1, new QTableWidgetItem(QString(newString.setNum(*j))));
		table->item( i,1)->setTextColor(QColor(255,85,127,255));
	}


}
