#include <QtGui>
#include <QApplication>

#include "ApplicationNode.h"
#include <stdexcept>
#include <H3D/X3DSAX2Handlers.h>

using namespace H3D;
using namespace FS;
using namespace std;

int main(int argc, char *argv[])
{
	int returnStatus = 1;
	try
	{
		// launch the application
		ApplicationNode applicationNode(argc, argv);
		returnStatus = applicationNode.exec();
	}
	catch(const H3D::X3D::XMLParseError &message)
	{
		cout << "H3D::X3D::XMLParseError: " << message << endl;
	}
	catch (const Exception::H3DAPIException &message)
	{
		cout << "Exception::H3DAPIException: " << message << endl;
	}
	catch (const Exception::H3DException &message)
	{
		cout << "Exception::H3DException: " << message << endl;
	}
	catch(const runtime_error &message)
	{
		cout << "runtime_error: " <<  message.what() << endl;
	}
	catch(...)
	{
		cout << "Unknown Exception caught by FsWisdom Application" << endl;
	}
	return returnStatus;
}

