/**
 * ApplicationNode.h
 *
 *  Created on: Feb 9, 2009
 *      Author: barrygr
 */

#ifndef APPLICATIONNODE_H_
#define APPLICATIONNODE_H_

#include <fstream>
#include <H3D/X3D.h>
#include <string.h>

#include <iostream>

#include <H3D/VrmlParser.h>
#include <H3D/GLUTWindow.h>
#include <H3D/Group.h>
#include <H3D/Transform.h>
#include <H3D/Scene.h>
#include <H3D/KeySensor.h>
#include <H3D/MouseSensor.h>
#ifndef MACOSX
#include <H3D/SpaceWareSensor.h>
#endif
#include <H3D/DEFNodes.h>
#include <H3D/Viewpoint.h>
#include <H3D/DeviceInfo.h>
#include <H3D/INIFile.h>
#include <H3D/ResourceResolver.h>
#include <H3D/PythonScript.h>
#include <H3D/NavigationInfo.h>
#include <H3D/H3DNavigation.h>

#include <GL/glew.h>
#include <QtOpenGL/QGLWidget>
#include <QtGui>
#include <QtOpenGL/QtOpenGL>

#include <H3D/X3D.h>
#include <H3D/H3DWindowNode.h>
#include <H3D/Scene.h>

#include <math.h>

#include <H3D/H3DForceEffect.h>
#include <H3D/SFVec3f.h>
#include <H3D/MFFloat.h>

#include <stdexcept>
#include <H3DUtil/Image.h>
#include <H3DUtil/TimeStamp.h>
#include <teem/nrrd.h>
#include <H3D/H3DNodeDatabase.h>
#include <H3D/SFVec3f.h>
#include <H3D/MFFloat.h>
#include <H3D/MFInt32.h>
#include <H3D/Node.h>
#include "GlWindowNode.h"
#include "qth3dload.h"
#include <fstream>
#include <H3D/X3D.h>
#include <string.h>

#include <iostream>

#include <H3D/VrmlParser.h>
#include <H3D/GLUTWindow.h>
#include <H3D/Group.h>
#include <H3D/Transform.h>
#include <H3D/Scene.h>
#include <H3D/KeySensor.h>
#include <H3D/MouseSensor.h>
#ifndef MACOSX
#include <H3D/SpaceWareSensor.h>
#endif
#include <H3D/DEFNodes.h>
#include <H3D/Viewpoint.h>
#include <H3D/DeviceInfo.h>
#include <H3D/INIFile.h>
#include <H3D/ResourceResolver.h>
#include <H3D/PythonScript.h>
#include <H3D/NavigationInfo.h>
#include <H3D/H3DNavigation.h>
#include "qth3dload.h"

H3D_API_EXCEPTION( QuitAPIException );

#define GET_INT(GROUP,VAR,DEFAULT)				\
	( ini_file.hasOption(GROUP,VAR) ? 			\
	atoi(ini_file.get( GROUP, VAR ).c_str()) :  \
	DEFAULT )

#define GET_BOOL(GROUP,VAR,DEFAULT)   			\
	( ini_file.hasOption(GROUP,VAR) ?     		\
	ini_file.getBoolean( GROUP, VAR ) : 		\
	DEFAULT )

#define GET4(ENV,GROUP,VAR,DEFAULT) 			\
	( getenv(ENV) ?                     		\
	string(getenv(ENV)) :             			\
	( ini_file.hasOption(GROUP,VAR) ? 			\
	ini_file.get( GROUP, VAR ) :    			\
	DEFAULT ) )

#define GET_ENV_INI_DEFAULT(ENV,PATH,GROUP,VAR,DEFAULT) 	\
	( getenv(ENV) ?                                         \
	string(getenv(ENV)) :                                 	\
	( ini_file.hasOption(GROUP,VAR) ?                     	\
	PATH + ini_file.get( GROUP, VAR ) :                 	\
	DEFAULT ) )

using namespace H3D;

namespace FS
{

class ApplicationNode : public QApplication, public H3D::X3DChildNode
{
	class QuitApplicationField: public AutoUpdate< SFString >
	{
	  virtual void update()
	  {
	    string s = static_cast< SFString * >(routes_in[0])->getValue();
	    if( s[0] == 27  ) // Esc button
	    	quit();
	  }
	};

public:
	ApplicationNode(int argc, char *argv[]);

	~ApplicationNode()
	{
		#ifdef H3DAPI_LIB
		  deinitializeH3D();
		  cout << "deinitializeH3D" <<endl;
		#endif
	}

	/// The ApplicationNode for this node.
	static H3D::H3DNodeDatabase database;

	/// Should we begin execution of the application
	bool readyToExec()
	{
		return !quitApplicationBeforeExec;
	}

private:
	AutoRef< KeySensor > keySensor;
	auto_ptr< QuitApplicationField > quitApplicationField;

	QtH3DLoad guiWindow;
	AutoRef<GlWindowNode> glWindow;
	AutoRef< Scene > scene;
	AutoRef< Group > group;
	auto_ptr<QTimer> timer;

	bool quitApplicationBeforeExec;

	string GetEnvIniDefaultFile( INIFile &ini_file,
			const string &ENV,
	        const string &DISPLAY_PATH,
	        const string &COMMON_PATH,
	        const string &GROUP,
	        const string &VAR );

	string GetHelpMessage(string programName);
};

}
#endif /* APPLICATIONNODE_H_ */



