/**
 * Vec3iTest.h
 *
 *  Created on: Jan 30, 2009
 *      Author: barrygr
 */

#ifndef VEC3ITEST_H_
#define VEC3ITEST_H_

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>
#include "../src/MaterialSegmentationModel.h"
#include "../src/Vec3i.h"

using namespace std;
using namespace FS;
using namespace H3D;

class Vec3iTest : public CppUnit::TestFixture
{
	CPPUNIT_TEST_SUITE( Vec3iTest );
	CPPUNIT_TEST( testLessthan );
	CPPUNIT_TEST_SUITE_END();
private:

	Vec3i *v_0_0_0;
	Vec3i *v_1_0_0;
	Vec3i *v_0_1_0;
	Vec3i *v_0_0_1;
	Vec3i *v_1_1_1;
	Vec3i *v_m_0_0;
	Vec3i *v_0_m_0;
	Vec3i *v_0_0_m;
	Vec3i *v_m_m_m;
	MaterialSegmentationModel msm;
public:
  void setUp()
  {
	  initializeH3D();

	  v_0_0_0 = new Vec3i(0,0,0);
	  v_1_0_0 = new Vec3i(1,0,0);
	  v_0_1_0 = new Vec3i(0,1,0);
	  v_0_0_1 = new Vec3i(0,0,1);
	  v_1_1_1 = new Vec3i(1,1,1);

	  v_m_0_0 = new Vec3i(-1,0,0);
	  v_0_m_0 = new Vec3i(0,-1,0);
	  v_0_0_m = new Vec3i(0,0,-1);
	  v_m_m_m = new Vec3i(-1,-1,-1);
  }

  void tearDown()
  {
	  delete v_0_0_0;
	  delete v_1_0_0;
	  delete v_0_1_0;
	  delete v_0_0_1;
	  delete v_1_1_1;
	  delete v_m_0_0;
	  delete v_0_m_0;
	  delete v_0_0_m;
	  delete v_m_m_m;
  }

  void testLessthan()
  {
        cout << "Vec3i" << endl;

	CPPUNIT_ASSERT( *v_0_0_0 < *v_1_0_0 );
	CPPUNIT_ASSERT( !(*v_0_0_1 < *v_0_0_0) );
	CPPUNIT_ASSERT( (*v_0_0_0 < *v_0_1_0) );
	CPPUNIT_ASSERT( !(*v_0_1_0 < *v_0_0_0) );
	CPPUNIT_ASSERT( (*v_0_0_0 < *v_0_0_1) );
	CPPUNIT_ASSERT( !(*v_0_0_1 < *v_0_0_0) );

	CPPUNIT_ASSERT( *v_0_0_0 < *v_1_0_0 );
    CPPUNIT_ASSERT( *v_1_0_0 < *v_0_1_0 );
    CPPUNIT_ASSERT( *v_0_1_0 < *v_0_0_1 );
    CPPUNIT_ASSERT( *v_0_0_1 < *v_1_1_1 );

    CPPUNIT_ASSERT( !(*v_1_0_0 < * v_0_0_0));
    CPPUNIT_ASSERT( !(*v_0_1_0 < * v_1_0_0));
    CPPUNIT_ASSERT( !(*v_0_0_1  < *v_0_1_0 ));
    CPPUNIT_ASSERT( !(*v_1_1_1 < * v_0_0_1));

    CPPUNIT_ASSERT(!(*v_0_0_0 < *v_0_0_0));
    CPPUNIT_ASSERT(!(*v_1_0_0 < *v_1_0_0));
    CPPUNIT_ASSERT(!(*v_0_1_0 < *v_0_1_0));
    CPPUNIT_ASSERT(!(*v_0_0_1 < *v_0_0_1));
    CPPUNIT_ASSERT(!(*v_1_1_1 < *v_1_1_1));

    CPPUNIT_ASSERT( !(*v_0_0_0 < *v_m_0_0 ));
    CPPUNIT_ASSERT( (*v_0_0_m < *v_0_0_0) );
    CPPUNIT_ASSERT( !(*v_0_0_0 < *v_0_m_0) );
    CPPUNIT_ASSERT( (*v_0_m_0 < *v_0_0_0) );
    CPPUNIT_ASSERT( !(*v_0_0_0 < *v_0_0_m) );
    CPPUNIT_ASSERT( (*v_0_0_m < *v_0_0_0) );

    CPPUNIT_ASSERT( !(*v_0_0_0 < *v_m_0_0) );
    CPPUNIT_ASSERT( !(*v_m_0_0 < *v_0_m_0) );
    CPPUNIT_ASSERT( !(*v_0_m_0 < *v_0_0_m) );
    CPPUNIT_ASSERT( !(*v_0_0_m < *v_m_m_m) );

    CPPUNIT_ASSERT( (*v_m_0_0 < * v_0_0_0));
    CPPUNIT_ASSERT( (*v_0_m_0 < * v_m_0_0));
    CPPUNIT_ASSERT( (*v_0_0_m  < *v_0_m_0 ));
    CPPUNIT_ASSERT( (*v_m_m_m < * v_0_0_m));

    CPPUNIT_ASSERT(!(*v_0_0_0 < *v_0_0_0));
    CPPUNIT_ASSERT(!(*v_m_0_0 < *v_m_0_0));
    CPPUNIT_ASSERT(!(*v_0_m_0 < *v_0_m_0));
    CPPUNIT_ASSERT(!(*v_0_0_m < *v_0_0_m));
    CPPUNIT_ASSERT(!(*v_m_m_m < *v_m_m_m));

	CPPUNIT_ASSERT_NO_THROW(*v_0_0_0 < *v_1_0_0);
  }

};


#endif /* VEC3ITEST_H_ */
