#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/ui/text/TestRunner.h>
#include "Vec3iTest.h"
#include "MaterialSegmentationModelTest.h"
#include "PartitionModelTest.h"
#include <teem/nrrd.h>
#include <cppunit/XmlOutputter.h>

using namespace CppUnit;

int main( int argc, char **argv)
{
  CPPUNIT_TEST_SUITE_REGISTRATION( PartitionModelTest );
  CPPUNIT_TEST_SUITE_REGISTRATION( MaterialSegmentationModelTest );
  CPPUNIT_TEST_SUITE_REGISTRATION( Vec3iTest );

  TextUi::TestRunner runner;
  TestFactoryRegistry &registry = TestFactoryRegistry::getRegistry();
  runner.addTest( registry.makeTest() );
  runner.run();

  // save results to an xml file
  ofstream xmlFileOut("cppTestResults.xml");
  XmlOutputter xmlOut(&runner.result(), xmlFileOut);
  xmlOut.write();

  return 0;
}
