/*
 * DefaultValues.cpp
 *
 *  Created on: Feb 18, 2009
 *      Author: jocke
 */
#include "DefaultValues.h"

using namespace std;
using namespace FS;

/// Add this node to the H3DNodeDatabase system.
H3D::H3DNodeDatabase DefaultValues::database("DefaultValues",
		&(newInstance<DefaultValues>),
		typeid( DefaultValues ),
		&X3DChildNode::database );

namespace DefaultValuesInternals
{
H3D::FIELDDB_ELEMENT( DefaultValues, scaleFactorField, INPUT_OUTPUT );
H3D::FIELDDB_ELEMENT( DefaultValues, translationZoomFactorField, INPUT_OUTPUT );
H3D::FIELDDB_ELEMENT( DefaultValues, rotationZoomFactorField, INPUT_OUTPUT );
H3D::FIELDDB_ELEMENT( DefaultValues, renderModeField, INPUT_OUTPUT );
H3D::FIELDDB_ELEMENT( DefaultValues, drillSpeedMaxField, INPUT_OUTPUT );
H3D::FIELDDB_ELEMENT( DefaultValues, cutRadiusField, INPUT_OUTPUT );
H3D::FIELDDB_ELEMENT( DefaultValues, objectToMoveField, INPUT_OUTPUT );
}

DefaultValues::DefaultValues(H3D::Inst< H3D::SFFloat> scaleFactorField,
		H3D::Inst< H3D::SFFloat> translationZoomFactorField,
		H3D::Inst< H3D::SFFloat> rotationZoomFactorField,
		H3D::Inst< H3D::SFInt32> renderModeField,
		H3D::Inst< H3D::SFFloat> drillSpeedMaxField,
		H3D::Inst< H3D::SFFloat> cutRadiusField,
		H3D::Inst< H3D::SFInt32> objectToMoveField
		):
			scaleFactorField(scaleFactorField),
			translationZoomFactorField(translationZoomFactorField),
			rotationZoomFactorField(rotationZoomFactorField),
			drillSpeedMaxField(drillSpeedMaxField),
			cutRadiusField(cutRadiusField),
			objectToMoveField(objectToMoveField)
{
	cout << "DefaultValues Model Constructing"<<endl;

	type_name = "DefaultValues";
	database.initFields( this );

	cout << "DefaultValues Model Constructed"<<endl;
}

void DefaultValues::initialize()
{
	cout<<"DefaultValues Model Initializing"<<endl;

	X3DChildNode::initialize();

	cout << scaleFactorField->getValue() << endl;
	cout << translationZoomFactorField->getValue() << endl;
	cout << rotationZoomFactorField->getValue() << endl;
	cout << drillSpeedMaxField->getValue() << endl;
	cout << cutRadiusField->getValue() << endl;
	cout << objectToMoveField->getValue() << endl;

	cout<<"DefaultValues Model Initialized"<<endl;
}

void DefaultValues::traverseSG( H3D::TraverseInfo &ti )
{
}


