/**
 * LoggingNode.cpp
 *
 *  Created on: Feb 27, 2009
 *      Author: barrygr
 */

#include "LoggingNode.h"

using namespace FS;

/// Add this node to the H3DNodeDatabase system.
H3D::H3DNodeDatabase LoggingNode::database("LoggingNode",
		&(newInstance<LoggingNode>),
		typeid( LoggingNode ),
		&X3DChildNode::database );

namespace LoggingNodeInternals
{
	H3D::FIELDDB_ELEMENT( LoggingNode, userLoggingPathField, INPUT_OUTPUT );
}

LoggingNode::LoggingNode(H3D::Inst< H3D::SFString  > userLoggingPathField)
:userLoggingPathField(userLoggingPathField)
{
	cout << "Logging Node Constructing"<<endl;

	type_name = "LoggingNode";
	database.initFields( this );

	cout << "Logging Node Constructed"<<endl;
}

LoggingNode::~LoggingNode()
{
	cout<<"Logging Node Destructed"<<endl;
}

void LoggingNode::initialize()
{
	cout<<"Logging Node Initializing"<<endl;

	cout<<"Logging Node Initialized"<<endl;
}
