/**
 * LoggingNode.h
 *
 *  Created on: Feb 27, 2009
 *      Author: barrygr
 */

#ifndef LOGGINGNODE_H_
#define LOGGINGNODE_H_

#include <H3D/X3DChildNode.h>
#include <H3D/SFString.h>

using namespace std;
using namespace H3D;

namespace FS
{

/**
 * Concerned with the logging of data to file
 */
class LoggingNode : public H3D::X3DChildNode
{
public:
	LoggingNode(H3D::Inst< H3D::SFString  > userLoggingPathField = 0);
	virtual ~LoggingNode();

	/**
	 * Initialize the Logging Node
	 */
	void initialize();

	/**
	 * The H3DNodeDatabase for this node
	 */
	static H3D::H3DNodeDatabase database;

	/**
	 * The location to where logs are stored for a particular user
	 */
	auto_ptr< H3D::SFString > 	userLoggingPathField;
};
}
#endif /* LOGGINGNODE_H_ */
